#pragma once

#include "components.hpp"
#include "dinkyecs.hpp"
#include "tser.hpp"
#include <string>
#include <vector>

namespace save {
  struct SaveData {
    components::Player player;
    std::vector<components::Position> position;
    std::vector<components::Motion> motion;
    std::vector<components::Combat> combat;

    DEFINE_SERIALIZABLE(SaveData, player, position, motion, combat);
  };

  void to_file(std::string path, DinkyECS::World &world);
  void from_file(std::string path, DinkyECS::World &world_out);
}
